﻿using System;
using System.Collections.Generic;
using System.Web;
using WebMatrix.WebData;

/// <summary>
/// RandomURL class generates Random URLs for applications.
/// </summary>
public class RandomURL
{
    var db = Database.Open("StarterSite");
    // List of characters and numbers to be used...
    private static List<int> numbers = new List<int>() {1, 2, 3, 4, 5, 6, 7, 8, 9, 0};
    private static List<char> characters = new List<char>() {'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o',
                                                        'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', 'A', 'B', 'C', 'D', 
                                                        'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 
                                                        'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '-', '_'};

    public static string GetURL () {    
        string URL = "";
        Random rand = new Random();
        // run the loop till I get a string of 10 characters
        for (int i = 0; i < 11; i++) {
            // Get random numbers, to get either a character or a number...
            int random = rand.Next(0, 3);
            if(random == 1) {
                // use a number
                random = rand.Next(0, numbers.Count);
                URL += numbers[random].ToString();
            } else {
                random = rand.Next(0, characters.Count);
                URL += characters[random].ToString();
            }
        }

        return URL;
    }

    public static bool Exists(string URL) {
        if(db.Query("SELECT * FROM RandomUrls WHERE ShortUrl = @0", URL).Count() > 0) {
            // Generate a new URL because the previous one had a match.
            return true;
        } else {
            return false;
        }
    }

    // Saves the URL in the database
    public static bool Save(string longUrl, string URL) {
        if(db.Execute("INSERT INTO RandomUrls (UrlString, ShortUrl) VALUES (@0, @1)", longUrl, URL) > 0) {
            // A row was added
            return true;
        } else {
            return false;
        }
    }

    public static void Redirect(string URL) {
        // Redirect the user to a page; depending on presence of the URL in the database
        var found = db.Query("SELECT * FROM RandomUrls WHERE ShortUrl = @0", shortUrl).Count() > 0;
        if(found) {
            Response.Redirect(db.Query("SELECT * FROM RandomUrls WHERE ShortUrl = @0", shortUrl).First().UrlString);
        } else {
            Response.Redirect("~/");
        }
    }
}